﻿<AML>
 <Item type="Method" id="6D103114C4EE49C4A9C9B77790536E56" action="add">
  <comments>2018-01-05 - MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
               Method Name:			SOP_Import_CI_Excel_Data
               Created By:     		Chan
               Creation Date:	    2019-02-01
               Description:
                   Read from the excel file

               Hooks:
                   Type:		sop_commercial_invoice
                   Event:		called from client method
                   Called by:	sop_ci_new_excelfile_import

               Inputs:
                   (1) file_id : checked in file_id from 'sop_ci_new_excelfile_import' method

                Revisions:
                Rev Date		Modified By		    Description
                2018-01-05      MyoThet         created method copied from SOP_Import_SaleInvoiceExcel_Data of TaxInvoice import
                                                comment out - Add new Part function - 
                                                    Part is managed by engineering team
                                                    Accounting manage stock and they create new item
                                                    Part is not with stock  itemtype
                                                    Stock is independent not linked with Part itemtype
                                                if SO No is not empty   : Create new Stock with item_number 'TBA-SO No-LineItemNo'
                2019-02-01      Chan            Set Method template.
                                                Update return Item instead of add sop_commercial_invoice and sop_commercial_invoice
                2019-02-01      Chan            Calculate total amount of stock item with discount and without discount.
                2019-02-01      Chan            Auto Part Number according by Stock.
                2019-02-21      Chan            If there is no project which get from Excel in Analytical Code,add that project  firstly.
           ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if (System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();
            string MethodName = "SOP_Import_CI_Excel_Data";

            //***** GRANT IDENTITY PRIVILEGES
            //grantIdentityPrivileges("Aras PLM");	// If this is enabled always revoke the privileges in the Finally below.
            //*******************************

            Item result = this; // default return value.
            /*create the Application object we can use in the member functions.*/
            Microsoft.Office.Interop.Excel.Application excelApp = new Microsoft.Office.Interop.Excel.Application();
            var myInnovator = this.getInnovator();
            try
            {
                string file_id = this.getProperty("file_id", "");
                Item sop_commercial_invoice_item = null;
                if (file_id == "") 
                {
                    return myInnovator.newError("'SOP_Import_CI_Excel_Data' : 'file_id' is empty.");
                }
                double subTotal = 0.00;
                string currency_id = "";
                string sale_account_id = "";
                string sale_tax_id = "";
                Item sale_account_item = null;
                Item sale_tax_item = null;
                
                /*******************************************************************************
                Begin - < Get Fixed Data For Required Field >
                *******************************************************************************/
                Item companyInfo = myInnovator.applyMethod("acc_getCompanyInfo", "");
                if (companyInfo.isError()) 
                {
                    return myInnovator.newError("'SOP_Import_CI_Excel_Data' : Get companyInfo");
                }
                
                if (companyInfo.getItemCount() > 0) 
                {
                    sale_account_id = companyInfo.getItemByIndex(0).getProperty("erp_sale_account");
                    sale_tax_id = companyInfo.getItemByIndex(0).getProperty("erp_basic_sale_tax");
                
                    sale_account_item = myInnovator.getItemById("acc_accountdetails", sale_account_id);
                    sale_tax_item = myInnovator.getItemById("acc_taxtemplate", sale_tax_id);
                }
                
                StringBuilder sb_currency = new StringBuilder("");
                sb_currency.Append("SELECT id ");
                sb_currency.Append("FROM innovator.acc_currency ");
                sb_currency.Append("WHERE acc_isdefault = 1 ");
                sb_currency.Append("AND is_current = 1");
                string sql_currency = sb_currency.ToString();
                Item currency = myInnovator.applySQL(sql_currency);
                if (currency.isError()) 
                {
                    return myInnovator.newError("Error : 'SOP_Import_SaleInvoiceExcel_Data' method : Get default currency");
                }
                if (currency.getItemCount() > 0) 
                {
                    currency = currency.getItemByIndex(0);
                    currency_id = currency.getProperty("id");
                }
                
                /*******************************************************************************
                CheckOut excel file under temp dir --> [app-virtual-dir]\\Innovator\\Server\\temp\\ 
                /******************************************************************************/
                string server_temp_dir = System.Web.HttpContext.Current.Server.MapPath("temp");
                
                string filePath = CheckOutFile(myInnovator, file_id, server_temp_dir);
                
                //open the workbook
                Microsoft.Office.Interop.Excel.Workbook workbook = excelApp.Workbooks.Open(filePath,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing, Type.Missing, Type.Missing,
                Type.Missing, Type.Missing);
            
                //select the first sheet        
                Microsoft.Office.Interop.Excel.Worksheet worksheet = (Microsoft.Office.Interop.Excel.Worksheet) workbook.Worksheets[1];
                //find the used range in worksheet
                Microsoft.Office.Interop.Excel.Range excelRange = (Microsoft.Office.Interop.Excel.Range) worksheet.UsedRange;
                //get an object array of all of the cells in the worksheet (their values)
                object[, ] valueArray = (object[, ]) excelRange.get_Value(Microsoft.Office.Interop.Excel.XlRangeValueDataType.xlRangeValueDefault);
                //access the cells
            
                /*Get Detail Data */
                string item = string.Empty;
                string poItem = string.Empty;
                string boxNo = string.Empty;
                string qty = string.Empty;
                string uom = string.Empty;
                string keurpn = string.Empty;
                string description = string.Empty;
                string sn = string.Empty;
                string unitprice = string.Empty;
                string totalprice = string.Empty;
                string margecell = string.Empty;
                string discount = string.Empty;
                string totalamount = string.Empty;
                int detailInital = worksheet.UsedRange.Rows.Count;
                
                /*Get Header*/
                string regno = string.Empty;
                string consignee = string.Empty;
                string shipTo = string.Empty;
                string PoNo = string.Empty;
                string SoNo = string.Empty;
                string PackingNo = string.Empty;
                string commercialNo = string.Empty;
                string projectNo = string.Empty;
                string country = string.Empty;
                string incoterm = string.Empty;
                string brand = string.Empty;
                string date = string.Empty;
            
                string strConsigneeCustomer = "";
                string strConsigneeAddress = "";
                string strConsigneePhone = "";
                string strConsigneeContact = "";
                string strConsigneePONumber = "";
            
                string strShipToCustomer = "";
                string strShipToAddress = "";
                string strShipToPhone = "";
                string strShipToEmail = "";
            
                // initialize column index
                int itemCol = 1; // ITEM
                int poitemCol = 1; // PO ITEM
                int boxnoCol = 1; // BOX NO.
                int qtyCol = 1; // QTY
                int uomCol = 1; // UOM
                int pnCol = 1; // PN
                int descCol = 1; // DESCRIPTION
                int snCol = 1; // S/N
                int priceCol = 1; // UNIT PRICE
                int totalCol = 1; // TOTAL PRICE
                int rowsCount = worksheet.UsedRange.Rows.Count;
                int columnCount = worksheet.UsedRange.Columns.Count;
                
                for (int row = 1; row <= worksheet.UsedRange.Rows.Count; ++row) 
                {
                    for (int column = 1; column <= worksheet.UsedRange.Columns.Count; ++column) 
                    {
                        if (row > rowsCount)
                        {
                            return sop_commercial_invoice_item;
                        }
                        if (row < rowsCount && valueArray[row, column] != null) 
                        {
            
                            /** Begin - Header Data **/
                            switch (valueArray[row, column].ToString().Trim().ToUpper()) 
                            {
                                case "CONSIGNEE":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            consignee = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
                                case "SHIP TO":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            shipTo = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
                                case "PO NO":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            PoNo = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
                                case "SO NO":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            SoNo = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
                                case "PACKING LIST NO":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            PackingNo = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
                                case "COMMERCIAL NO":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            commercialNo = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
            
                                case "PROJECT NO":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            projectNo = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
            
                                case "COUNTRY OF \nORIGIN":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            country = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
            
                                case "INCOTERM":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            incoterm = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
            
                                case "BRAND":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            brand = valueArray[row, column + 1].ToString();
                                        }
                                    }
                                    break;
            
                                case "DATE":
                                    {
                                        if (valueArray[row, column + 1] != null) {
                                            date = ((DateTime) valueArray[row, column + 1]).ToString("yyyy-MM-ddThh:mm:ss");
                                        }
                                    }
                                    break;
                            }
            
                            regno = valueArray[8, 2].ToString();
            
                            /** End - Header Data **/
            
                            if (valueArray[row, column].ToString().Trim().ToUpper() == "ITEM") 
                            {
                                detailInital = row;
                                itemCol = column;
                                
                                /** Begin < Adding Sale Header > **/
            
                                /** Consignee **/
                                string[] arrConsignee = consignee.Split('\n');
                                if (arrConsignee.Length > 0) 
                                {
                                    strConsigneeCustomer = arrConsignee[0];
                                }
            
                                if (arrConsignee.Length > 3) 
                                {
                                    strConsigneeAddress = arrConsignee[1] + "\n" + arrConsignee[2] + "\n" + arrConsignee[3];
                                }
            
                                for (int c = 0; c < arrConsignee.Length; c++) 
                                {
                                    if (arrConsignee[c].Contains("Ph.")) 
                                    {
                                        strConsigneePhone = arrConsignee[c];
                                        string[] arrConsigneePhone = strConsigneePhone.Split('h');
                                        strConsigneePhone = arrConsigneePhone[1];
                                    }
            
                                    if (arrConsignee[c].Contains("Contact")) 
                                    {
                                        strConsigneeContact = arrConsignee[c];
                                        string[] arrConsigneeContact = strConsigneeContact.Split(':');
                                        strConsigneeContact = arrConsigneeContact[1];
                                    }
            
                                    if (arrConsignee[c].Contains("PO Number")) 
                                    {
                                        strConsigneePONumber = arrConsignee[c];
                                        string[] arrConsigneePoNumber = strConsigneePONumber.Split(':');
                                        strConsigneePONumber = arrConsigneePoNumber[1];
                                    }
            
                                }
            
                                /** ShipTo **/
                                string[] arrShipTo = shipTo.Split('\n');
                                if (arrShipTo.Length > 0) 
                                {
                                    strShipToCustomer = arrShipTo[0];
                                }
            
                                if (arrShipTo.Length > 3) 
                                {
                                    strShipToAddress = arrShipTo[1] + "\n" + arrShipTo[2] + "\n" + arrShipTo[3];
                                }
            
                                for (int c = 0; c < arrShipTo.Length; c++) 
                                {
                                    if (arrShipTo[c].Contains("Ph.")) 
                                    {
                                        strShipToPhone = arrShipTo[c];
                                        string[] arrShipToPhone = strShipToPhone.Split('h');
                                        strShipToPhone = arrShipToPhone[1];
                                    }
            
                                    if (arrShipTo[c].Contains("mail")) 
                                    {
                                        strShipToEmail = arrShipTo[c];
                                        string[] arrShipToEmail = strShipToEmail.Split(':');
                                        strShipToEmail = arrShipToEmail[1];
                                    }
                                }
            
                                sop_commercial_invoice_item = myInnovator.newItem("sop_commercial_invoice");
                                sop_commercial_invoice_item.setProperty("sop_commercial_no", "INV_NO_FROM_EXCEL");
                                sop_commercial_invoice_item.setProperty("sop_invoice_no", commercialNo);
                                sop_commercial_invoice_item.setProperty("sop_invoice_date", date);
                                sop_commercial_invoice_item.setProperty("erp_company", companyInfo.getItemByIndex(0).getProperty("id"));
                                sop_commercial_invoice_item.setPropertyItem("acc_account", sale_account_item);
                                sop_commercial_invoice_item.setPropertyItem("acc_tax", sale_tax_item);
                                sop_commercial_invoice_item.setProperty("pop_currency", currency_id);
            
                                Item itemCustomer = getCustomer(myInnovator, strConsigneeCustomer);
                                sop_commercial_invoice_item.setPropertyItem("sop_customer", itemCustomer);
                                sop_commercial_invoice_item.setProperty("sop_customer_address", strConsigneeAddress);
                                sop_commercial_invoice_item.setProperty("sop_customer_phone", strConsigneePhone);
                                sop_commercial_invoice_item.setProperty("sop_invoice_to_contact", strConsigneeContact);
            
                                Item itemShipToCustomer = getCustomer(myInnovator, strShipToCustomer);
                                sop_commercial_invoice_item.setPropertyItem("sop_ship_to", itemShipToCustomer);
                                sop_commercial_invoice_item.setProperty("sop_ship_to_address", strShipToAddress);
            
                                /*POP*/
                                sop_commercial_invoice_item.setProperty("pop_currency_operator", "/");
                                sop_commercial_invoice_item.setProperty("pop_currency_rate", "1");
                                sop_commercial_invoice_item.setProperty("pop_gst_amount", "0.00");
                                sop_commercial_invoice_item.setProperty("pop_gst_percent", "7");
                                sop_commercial_invoice_item.setProperty("pop_sub_amount", "0.00");
                                sop_commercial_invoice_item.setProperty("pop_total_amount", "0.00");
                                sop_commercial_invoice_item.setProperty("acc_allocation_total", "0.00");
                                sop_commercial_invoice_item.setProperty("pop_total_currency_amount", "0.00");
                                sop_commercial_invoice_item.setProperty("pop_total_currency_fullamount", "0.000000");
            
                                /*SOP*/
                                sop_commercial_invoice_item.setProperty("sop_owing_amount", "0.00");
                                sop_commercial_invoice_item.setProperty("sop_payment_amount", "0.00");
            
                                sop_commercial_invoice_item.setProperty("sop_po_reference", PoNo);
            
                                Item sopSaleOrder = myInnovator.newItem("sop_sale_order", "get");
                                sopSaleOrder.setProperty("keyed_name", SoNo);
                                sopSaleOrder = sopSaleOrder.apply();
                                if (!sopSaleOrder.isError() && sopSaleOrder.getItemCount() > 0) 
                                {
                                    sop_commercial_invoice_item.setPropertyItem("sop_sale_order", sopSaleOrder.getItemByIndex(0));
                                }
                                
                                //Project
                                
                                Item accProject = myInnovator.newItem("hr_project", "get");
                                accProject.setProperty("pr_project_code", projectNo);
                                accProject = accProject.apply();
                                var count = accProject.getItemCount();
                                if (!accProject.isError() && accProject.getItemCount() > 0) 
                                {
                                    sop_commercial_invoice_item.setPropertyItem("acc_project", accProject.getItemByIndex(0));
                                }
                                else//2019-02-21
                                {
                                    Item addProject = myInnovator.newItem("hr_project", "add");
                                    addProject.setProperty("pr_project_code", projectNo);
                                    addProject.setProperty("pr_project_name", projectNo);
                                    addProject.setProperty("pr_start_date", date);
                                    addProject.setProperty("pr_end_date", date);
                                    addProject.setProperty("pr_estimated_costing", "100");
                                    addProject = addProject.apply();
                                    sop_commercial_invoice_item.setPropertyItem("acc_project", addProject);
                                }
            
                                sop_commercial_invoice_item.setProperty("sop_packing_list_no", PackingNo);
                                sop_commercial_invoice_item.setProperty("sop_country_of_origin", country);
                                sop_commercial_invoice_item.setProperty("sop_incoterm", incoterm);
                                sop_commercial_invoice_item.setProperty("sop_brand", brand);
            
                                /** End < Adding Sale Header > **/
                            }
            
                            switch (valueArray[row, column].ToString().Trim().ToUpper()) 
                            {
                                case "PO ITEM":
                                    {
                                        poitemCol = column;
                                    }
                                    break;
            
                                case "BOX NO.":
                                    {
                                        boxnoCol = column;
                                    }
                                    break;
            
                                case "QTY":
                                    {
                                        qtyCol = column;
                                    }
                                    break;
            
                                case "UOM":
                                    {
                                        uomCol = column;
                                    }
                                    break;
            
                                case "PN":
                                    {
                                        pnCol = column;
                                    }
                                    break;
            
                                case "DESCRIPTION":
                                    {
                                        descCol = column;
                                    }
                                    break;
            
                                case "S/N":
                                    {
                                        snCol = column;
                                    }
                                    break;
                            }
            
                            if (valueArray[row, column].ToString().Trim().ToUpper().StartsWith("UNIT PRICE")) 
                            {
                                priceCol = column;
                            }
            
                            if (valueArray[row, column].ToString().Trim().ToUpper().StartsWith("TOTAL PRICE")) 
                            {
                                totalCol = column;
                            }
            
                            if (row > detailInital && valueArray[row, itemCol] != null && column == itemCol) 
                            {
                                excelRange = (Microsoft.Office.Interop.Excel.Range) worksheet.Cells[row, 2];
                                if (!(bool) excelRange.MergeCells) 
                                {
                                    item = valueArray[row, itemCol].ToString();
                                    poItem = valueArray[row, poitemCol].ToString();
                                    boxNo = valueArray[row, boxnoCol].ToString();
                                    qty = valueArray[row, qtyCol].ToString();
                                    uom = valueArray[row, uomCol].ToString();
                                    keurpn = valueArray[row, pnCol].ToString();
                                    if (keurpn.Contains("REV")) 
                                    {
                                        string[] arrkeurpn = keurpn.Split(' ');
                                        keurpn = arrkeurpn[0];
                                    }
            
                                    description = valueArray[row, descCol].ToString();
                                    sn = valueArray[row, snCol].ToString();
                                    unitprice = valueArray[row, priceCol].ToString();
                                    totalprice = valueArray[row, totalCol].ToString();
                                    subTotal = subTotal + Convert.ToDouble(totalprice);
            
                                    /** Begin <Add Detail Data> **/
            
                                    string stock = getStock(myInnovator, keurpn);
                                    if (stock == "") 
                                    {
                                        string itemNumber = "";
            
                                        /** if SO No is not empty   : 
                                            Create new Stock with item_number 'TBA-SO No-LineItemNo' **/
                                        if (SoNo != "" && SoNo != null) {
                                            itemNumber = "TBA-" + SoNo + "-" + item;
                                        }
            
                                        stock = getStock(myInnovator, itemNumber);
                                        if (stock == "") 
                                        {
                                            Item addStock = this.newItem("stk_stock_setup", "add");
                                            addStock.setProperty("stk_code", itemNumber);
                                            addStock.setProperty("stk_description", description);
                                            addStock.setProperty("stk_price", unitprice);
                                            addStock = addStock.apply();
            
                                            if (addStock.isError()) {
                                                return myInnovator.newResult("error : Add new Stock : " + itemNumber);
                                            }
            
                                        }
            
                                        keurpn = itemNumber;
                                    }
                                    
                                    
                                    
                                    Item saleDetail = myInnovator.newItem("sop_commercial_invoice_details");
                                    saleDetail.setProperty("stk_code", getStock(myInnovator, keurpn));
                                    saleDetail.setProperty("stk_part_number", getPart(myInnovator, keurpn));//2019-02-01 Chan
                                    saleDetail.setProperty("stk_description", description);
                                    saleDetail.setProperty("stk_qty", qty);
                                    saleDetail.setProperty("stk_uom", getUOM(myInnovator, uom));
                                    saleDetail.setProperty("stk_price", unitprice);
                                    saleDetail.setProperty("stk_total_amount", totalprice);
                                    saleDetail.setPropertyItem("stk_location", getLocation(myInnovator));
                                    saleDetail.setProperty("sop_po_item", poItem);
                                    saleDetail.setProperty("sop_box_no", boxNo);
                                    saleDetail.setProperty("sop_serial_no", sn);
                                    sop_commercial_invoice_item.setProperty("pop_sub_amount", subTotal.ToString());
                                    sop_commercial_invoice_item.addRelationship(saleDetail);
                                    
                                    /** End <Add Detail Data> **/
            
                                } 
                                else 
                                {
                                    margecell = valueArray[row, 2].ToString();
                                    excelRange = (Microsoft.Office.Interop.Excel.Range) worksheet.Cells[row, totalCol];
                                    if (!(bool) excelRange.MergeCells && (valueArray[row, totalCol] != null || valueArray[row + 1, totalCol] != null)) 
                                    {
                                        totalamount = valueArray[row, totalCol].ToString();
                                        discount = "0";
                                        if (margecell == "LESS DISCOUNT - USD")
                                        {
                                            totalamount = valueArray[row + 1, totalCol].ToString();
                                            discount = valueArray[row, totalCol].ToString();
                                        }
                                        row = worksheet.UsedRange.Rows.Count + 1;
            
                                        if (!string.IsNullOrEmpty(totalamount)) 
                                        {
                                            sop_commercial_invoice_item.setProperty("pop_lumpsum_discount", discount.ToString());
                                            sop_commercial_invoice_item.setProperty("pop_total_amount", totalamount.ToString());
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                //clean up stuffs
                workbook.Close(false, Type.Missing, Type.Missing);
                Marshal.ReleaseComObject(workbook);  
                
                result = sop_commercial_invoice_item;
            }
            //throw ArgumentExceptions for errors which are anticipated, such as validating a user has updated certain properties
            //error is plainly presented to the user
            catch (System.ArgumentException argex)
            {
                result = myInnovator.newError(argex.Message);
                result.setErrorCode("0"); //only use if this method is called from another method
            }
            //throw ApplicationExceptions for any other errors which are checked for in code, such as when a query returns an error item
            //error is presented with a bold header including the methodname
            catch (System.ApplicationException appex)
            {
                result = myInnovator.newError(string.Format("<b>ERROR in method {0}</b><br>{1}", MethodName, appex.Message));
                result.setErrorCode("0"); //only use if this method is called from another method
            }
            //catch any other unexpected exceptions
            //error is presented with a bold header including the methodname
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("<b>SYSTEM EXCEPTION in method {0}</b><br>{1}", MethodName, ex.Message));
                result.setErrorCode("0"); //only use if this method is called from another method
            }
            finally
            {

                //clean up stuffs
                excelApp.Quit();
                Marshal.FinalReleaseComObject(excelApp);

                //**** REVOKE IDENTITY PRIVILEGES
                //revokeIdentityPrivileges();
                //*******************************
            }
            return result;

            }

        private Item getLocation(Innovator myInnovator) 
        {
            Item itemLocation = myInnovator.newItem("stk_location", "get");
            itemLocation = itemLocation.apply();
            Item itmLocation = itemLocation.getItemByIndex(0);
            return itmLocation;
        }

        private string getStock(Innovator myInnovator, string itemNumber) 
        {
            string stkID = "";
        
            Item itemStock = myInnovator.newItem("stk_stock_setup", "get");
            itemStock.setProperty("stk_code", itemNumber.Trim());
            itemStock.setPropertyCondition("stk_code", "eq");
            itemStock = itemStock.apply();
            if (itemStock.getItemCount() > 0) {
                stkID = itemStock.getID();
            }
            return stkID;
        }

        private string getPart(Innovator myInnovator, string itemNumber) 
        {
            string stkParatNumber = "";
            
            Item itemPart = myInnovator.newItem("part", "get");
            itemPart.setProperty("item_number", itemNumber.Trim());
            itemPart.setPropertyCondition("item_number", "eq");
            itemPart = itemPart.apply();
            if (itemPart.getItemCount() > 0) {
                stkParatNumber = itemNumber;
            }
            return stkParatNumber;
        }

        private Item getCustomer(Innovator myInnovator, string customer) 
        {
            Item itmCustomer = myInnovator.newItem("customer", "get");
            itmCustomer.setProperty("name", customer.Trim());
            itmCustomer.setPropertyCondition("name", "eq");
            itmCustomer = itmCustomer.apply();
            return itmCustomer;
        }

        private string getUOM(Innovator myInnovator, string uom) 
        {
            string uomID = string.Empty;
            Item itmUom = myInnovator.newItem("stk_uom", "get");
            itmUom.setProperty("stk_uom_code", uom);
            itmUom.setPropertyCondition("stk_uom_code", "eq");
            itmUom = itmUom.apply();
            uomID = itmUom.getID();
            return uomID;
        }

        public static string CheckOutFile(Innovator myInnovator, string file_id, string check_out_dir) 
        {
            string fileName = "";
            Item file_item = myInnovator.newItem("File", "get");
            file_item.setProperty("id", file_id);
            file_item = file_item.apply();
        
            if (!file_item.isError() && file_item.getItemCount() > 0) {
                fileName = file_item.getProperty("filename", "");
            }
        
            string FileDirectory = Path.Combine(check_out_dir, fileName);
            try {
                if (File.Exists(FileDirectory)) {
                    File.Delete(FileDirectory);
                }
                Item get_file_request = myInnovator.newItem();
                get_file_request.setType("File");
                get_file_request.setAction("get");
                get_file_request.setID(file_id);
                Item fileItem = get_file_request.apply();
                Item checkoutResult = fileItem.checkout(check_out_dir);
                if (checkoutResult.isError())
                    throw new Exception(string.Format("Failed to check-out file with ID={0}: {1}", file_id));
            } catch {}
            return FileDirectory;
        }

        public static string GetDefaultVaultOfLoginUser(Innovator myInnovator) 
        {
            string default_vault = "";
            string user_id = myInnovator.getUserID();
            Item user_item = myInnovator.newItem("user", "get");
            user_item.setID(user_id);
            user_item.setAttribute("select", "default_vault");
            user_item = user_item.apply();
            if (!user_item.isError() && user_item.getItemCount() > 0) {
                default_vault = user_item.getProperty("default_vault");
            }
            return default_vault;
]]></method_code>
  <method_type>C#</method_type>
  <name>SOP_Import_CI_Excel_Data</name>
 </Item>
</AML>